﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Windows.Forms;
using System.Drawing;

namespace TemplateCreator
{
    class SlozenyBlokXsl
    {
        private IList<string> seznam;

        public IList<string> Seznam
        {
            get { return seznam; }
            set { seznam = value; }
        }

        public SlozenyBlokXsl()
        {
            seznam = new List<string>();
        }

        public void NaplnitSeznam(TreeNode tn)
        {
            TreeNodeCollection tnc = tn.Nodes;

            foreach (TreeNode item in tnc)
            {
                seznam.Add(item.Text);
            }
        }

        public string SestavXsl(Format f)
        {
            string s = "";
            string pismo = "font-family=\"" + f.JmenoFontu.Name.ToString() + "\" font-size=\"" + (int)f.VelikostPisma + "pt\" color=\"" + ColorTranslator.ToHtml(f.BarvaPisma).ToLower() + "\" ";
            string styl = "";
            if ((f.StylPisma & FontStyle.Bold) != 0)
            {
                styl += "font-weight=\"bold\" ";
            }
            if ((f.StylPisma & FontStyle.Underline) != 0)
            {
                styl += "text-decoration=\"underline\" ";
            }
            if ((f.StylPisma & FontStyle.Italic) != 0)
            {
                styl += "font-style=\"italic\" ";
            }

            string zarovnani = "";
            switch (f.ZarovnaniPisma)
            {
                case Zarovnani.LEFT:
                    zarovnani += "text-align=\"left\" ";
                    break;
                case Zarovnani.RIGHT:
                    zarovnani += "text-align=\"right\" ";
                    break;
                case Zarovnani.JUSTIFY:
                    zarovnani += "text-align=\"justify\" ";
                    break;
                case Zarovnani.CENTER:
                    zarovnani += "text-align=\"center\" ";
                    break;
                default:
                    zarovnani += "";
                    break;
            }

            string mezera = "padding-bottom=\"" + f.Mezera + "pt\" ";

            foreach (var item in seznam)
            {

                s += "<fo:block " + zarovnani + styl + pismo + mezera +">";
                s += @"<xsl:value-of select=""" + item + @""" />";
                s += @"</fo:block>";
            }

            return s;
        }

    }
}
