﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Xml.Linq;
using System.Xml.XPath;

namespace TemplateCreator
{
    public partial class Tabulka : Form
    {
        public TabulkaXsl Tbl { get; set; }

        private int vybranySloupec = -1;

        public Tabulka()
        {
            InitializeComponent();
            this.KeyPreview = true;

            this.Width = 0;

        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.Width = 0;
            foreach (var item in Tbl.SirkySloupcu)
            {
                this.Width += item;
            }

            if (Tbl.Data != null)
            {
                for (int i = 0; i < Tbl.Nadpisy.Count; i++)
                {
                    ColumnHeader header = new ColumnHeader();
                    header.Text = Tbl.Nadpisy[i];
                    header.Width = Tbl.SirkySloupcu[i];
                    listView1.Columns.Add(header);
                }

                



                TreeNodeCollection tColl = Tbl.Data.FirstNode.Nodes;

                //int j = 0;
                //ListViewItem lvi = new ListViewItem(new string[Tbl.Nadpisy.Count]);
                //foreach (TreeNode item in tColl)
                //{
                //    lvi.SubItems[j++].Text = item.Text;
                //}

                //listView1.Items.Add(lvi);

                //XElement element = XElement.Load(Tbl.XmlData.ToString());
                //string hledanyText = Tbl.Data.FirstNode.Text; 
                //IEnumerable<XElement> hledaneElemnty = from el in Tbl.XmlData.Elements() select el;

                //foreach (XElement item in hledaneElemnty)
                //{
                //    ListViewItem lvi = new ListViewItem(new string[Tbl.Nadpisy.Count]);
                //    for (int i = 0; i < Tbl.Nadpisy.Count; i++)
                //    {
                //        lvi.SubItems[i].Text = item.Value;
                //    }
                //    listView1.Items.Add(lvi);
                //}

                foreach (XElement item in Tbl.XmlData.Descendants(Tbl.Data.FirstNode.Text))
                {
                    ListViewItem lvi = new ListViewItem(new string[Tbl.Nadpisy.Count]);
                    int i = 0;
                    foreach (var elemnt in item.Descendants())
                    {
                        lvi.SubItems[i].Text = elemnt.Value;
                        i++;
                    }
                    listView1.Items.Add(lvi);
                }

                listView1.View = View.Details;
            }
            else
            {
                MessageBox.Show("Nemám data!", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        protected override void OnFormClosed(FormClosedEventArgs e)
        {
            base.OnFormClosed(e);
            if (DialogResult == DialogResult.Cancel)
            {
                return;
            }

            Tbl.SirkaTabulky = 0;
            foreach (var item in Tbl.SirkySloupcu)
            {
                Tbl.SirkaTabulky += item;
            }
        }

        private void Tabulka_Load(object sender, EventArgs e)
        {
            this.listView1.ColumnClick += listView1_ColumnClick;
            this.listView1.ColumnWidthChanged += listView1_ColumnWidthChanged;
        }

        void listView1_ColumnWidthChanged(object sender, ColumnWidthChangedEventArgs e)
        {
            Tbl.SirkySloupcu[e.ColumnIndex] = listView1.Columns[e.ColumnIndex].Width;
        }

        void listView1_ColumnClick(object sender, ColumnClickEventArgs e)
        {
            vybranySloupec = e.Column;
            textBox1.Text = listView1.Columns[e.Column].Text;
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                listView1.Columns[vybranySloupec].Text = textBox1.Text;
                Tbl.Nadpisy[vybranySloupec] = textBox1.Text;

                try
                {
                    vybranySloupec += 1;
                    textBox1.Text = listView1.Columns[vybranySloupec].Text;
                }
                catch (Exception)
                {
                    vybranySloupec = 0;
                    textBox1.Text = listView1.Columns[vybranySloupec].Text;
                }
            }
        }
    }
}
