﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Windows.Forms;
using System.Xml.Linq;
using System.Drawing;

namespace TemplateCreator
{
    public class TabulkaXsl
    {
        private IList<string> nadpisy;

        public IList<string> Nadpisy
        {
            get { return nadpisy; }
            set { nadpisy = value; }
        }

        private TreeNode data;

        public TreeNode Data
        {
            get { return data; }
            set
            {
                data = value;
                TreeNodeCollection tColl = data.FirstNode.Nodes;
                foreach (TreeNode item in tColl)
                {
                    xpath.Add(item.Text);
                }
            }
        }

        private int sirka;

        public int SirkaTabulky
        {
            get { return sirka; }
            set { sirka = value; }
        }

        private IList<int> sirkySloupcu;

        public IList<int> SirkySloupcu
        {
            get { return sirkySloupcu; }
            set { sirkySloupcu = value; }
        }

        private IList<string> xpath;

        public IList<string> XPath
        {
            get { return xpath; }
            //    set { xpath = value; }
        }

        private XDocument xmlData;

        public XDocument XmlData
        {
            get { return xmlData; }
            set { xmlData = value; }
        }

        public TabulkaXsl()
        {
            nadpisy = new List<string>();
            sirkySloupcu = new List<int>();

            xpath = new List<string>();
        }

        public string SestavXsl(Graphics g, Format f)
        {
            string pismo = "font-family=\"" + f.JmenoFontu.Name.ToString() + "\" font-size=\"" + (int)f.VelikostPisma + "pt\" color=\"" + ColorTranslator.ToHtml(f.BarvaPisma).ToLower() + "\" ";
            string styl = "";
            if ((f.StylPisma & FontStyle.Bold) != 0)
            {
                styl += "font-weight=\"bold\" ";
            }
            if ((f.StylPisma & FontStyle.Underline) != 0)
            {
                styl += "text-decoration=\"underline\" ";
            }
            if ((f.StylPisma & FontStyle.Italic) != 0)
            {
                styl += "font-style=\"italic\" ";
            }

            string zarovnani = "";
            switch (f.ZarovnaniPisma)
            {
                case Zarovnani.LEFT:
                    zarovnani += "text-align=\"left\" ";
                    break;
                case Zarovnani.RIGHT:
                    zarovnani += "text-align=\"right\" ";
                    break;
                case Zarovnani.JUSTIFY:
                    zarovnani += "text-align=\"justify\" ";
                    break;
                case Zarovnani.CENTER:
                    zarovnani += "text-align=\"center\" ";
                    break;
                default:
                    zarovnani += "";
                    break;
            }

            string mezera = "padding-bottom=\"" + f.Mezera + "pt\" ";

            string xsl = "";
            xsl += @"<fo:table " + zarovnani + pismo + @">";
            for (int i = 0; i < nadpisy.Count; i++)
            {
                int cisloSloupce = i + 1;
                xsl += @"<fo:table-column column-number=""" + cisloSloupce + @""" column-width=""" + PixelToCentimeter(sirkySloupcu[i], g) + @"cm""></fo:table-column>";
            }

            xsl += "<fo:table-body><fo:table-row>";

            for (int i = 0; i < nadpisy.Count; i++)
            {
                int cisloSloupce = i + 1;
                xsl += @"<fo:table-cell column-number=""" + cisloSloupce + @""">";
                xsl += @"<fo:block " + styl + mezera + ">";
                xsl += nadpisy[i];
                xsl += @"</fo:block></fo:table-cell>";
            }

            xsl += "</fo:table-row>";
            xsl += @"<xsl:for-each select=""" + data.FirstNode.Text + @""">";
            xsl += "<fo:table-row>";



            for (int i = 0; i < nadpisy.Count; i++)
            {
                int cisloSloupce = i + 1;
                xsl += @"<fo:table-cell column-number=""" + cisloSloupce + @""">";
                xsl += @"<fo:block " + pismo + zarovnani + mezera + @">";
                xsl += @"<xsl:value-of select=""" + xpath[i] + @"""/></fo:block></fo:table-cell>";
            }

            /* tabulka */


            xsl += @"</fo:table-row>";
            xsl += @"</xsl:for-each>";
            xsl += "</fo:table-body></fo:table>";

            return xsl;
        }

        string PixelToCentimeter(int pixel, Graphics gr)
        {
            double centimeter = -1;


            centimeter = (pixel * 2.54d) / gr.DpiY;
            string s = centimeter.ToString();
            s = s.Replace(",", ".");


            return s;
        }

    }
}
